View Issue Details

IDProjectCategoryView StatusLast Update
0002303Far ManagerPanelpublic2015-02-10 16:25
ReporterVertigoAssigned ToDrKnS 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Platformx64OSWindowsOS Version7
Product Version3.0 
Target VersionFixed in Version3.0 
Summary0002303: Новые типы Reparse Point в Windows 8/2012
DescriptionWindows Server 2012 поддерживает 2 новых типа reparse point, согласно winnt.h из Windows 8 SDK:

#define IO_REPARSE_TAG_DEDUP (0x80000013L)
#define IO_REPARSE_TAG_NFS (0x80000014L)

Про второй ничего сказать не могу (хотя очевидно, что это NFS), а вот первый, называемый "дедупликатор", у нас на серверах включён.
Суть его в том, что совпадающие куски файлов хранятся в одном экземпляре.
При этом у файла появляется атрибут Sparse. Самое печальное, что Фар отображает его тип как ?Symlink? (что и понятно - тип неизвестный), а в диалоге атрибутов по Ctrl-A в поле Symlink - полную ересь (смахивает на чтение из непонятной области памяти). Эксплорер же при этом файл показывает как обычный с отображением размера. Хотелось бы того же и от Фара, ибо очень сильно напрягает, когда в панели не видно размер.
Additional InformationЕсли нужна ещё какая-то информация, или помощь в тестировании - рад посодействовать.
TagsNo tags attached.
Build3215

Relationships

related to 0001711 closed2useven10 Symbol links created by SIS (single instance storage) are not handled properly 
related to 0002935 closed2useven10 <Symlink> to files not showing 

Activities

DrKnS

2013-02-14 23:00

administrator   bugnote:0010294

Можете сделать небольшой vhd с такими объектами?

DrKnS

2013-02-14 23:26

administrator   bugnote:0010295

После 3195 это по крайней мере должно опознаваться и в CtrlA не будет ереси.

Vertigo

2013-02-15 13:28

reporter   bugnote:0010297

Да, в 3195 отображается намного лучше.
С VHD, скорее всего, будут сложности, т.к. сам по себе такой диск без работающего с ним Windows Server 2012 скорее всего смысла не имеет. А если под рукой есть сервер, то включить на нём дедупликацию не составляет труда.
http://blogs.technet.com/b/klince/archive/2012/04/02/fun-with-deduplication-in-windows-8-server.aspx

Я вот думаю, может проблема в том, что у такого дедуплицированного файла стоят сразу два атрибута - Reparse point и Sparse? Фар видит наличие первого и априори считает файл ссылкой.
Кстати, если открыть файл на просмотр по F3 (или ещё как либо обратиться к физическому содержимому), то WS на время "воскрешает" файл к жизни, оба атрибута снимаются, и Фар отображает файл нормально, как реальный файл.
Может, такой случай - исключение, и его надо обрабатывать отдельно?

2useven10

2013-02-18 17:36

developer   bugnote:0010314

3206

DrKnS

2013-02-18 17:58

administrator   bugnote:0010315

2useven10, а у майкрософта где-то официально написано, что репарспоинты с тегом dedup не следует считать репарспоинтами?

Как-то очень подозрительно всё это выглядит.

2useven10

2013-02-18 18:11

developer   bugnote:0010316

DrKnS, не видел/не искал, как не видел и того, что наличие флага репарспоинт означает неактульность поля размер файла.

1) SPARSE косвенный признак того, что имеем дело с файлом.
2) Это работает на server 2012 с дедупами.

2useven10

2013-02-18 21:15

developer   bugnote:0010317

Есть ещё один недочёт - некорректно показываются атрибуты.
Если есть репарспоинт 'L', Sparse '$' (у эксплорера 'P') не показывается.
В итоге для дедупов у нас 'L', в эксплорере 'PL'.

Vertigo

2013-02-18 21:22

reporter   bugnote:0010318

DrKnS, я тоже не видел. Похоже на попытку впихнуть новый функционал в то, что уже есть. Про Sparse согласен с 2useven10.

2useven10, этот недочёт появился после последних исправлений? Раньше показывалось два атрибута - у меня на этом факте подсветка файлов настроена (у линков без sparse по юниксовому ставится ~ в качестве марка).

2useven10

2013-02-18 22:28

developer   bugnote:0010319

Vertigo, это только при отображении в панелях в поле атрибутов файла.

2useven10

2013-02-19 12:20

developer   bugnote:0010320

3211

a) разделение флагов SPARSE и REPARSEPOINT в строке атрибутов
b) символ для SPARSE изменён '$' -> 'P' -- отпишитесь, если это 'плохо'
c) если строка атрибутов слишком длинная - убираем из неё пробелы

Vertigo

2013-02-19 14:09

reporter   bugnote:0010321

2useven10, про атрибуты понял. Просто никогда этим столбцом не пользовался. Да, в 3205 только 'L'. Проверить на старших билдах не могу, т.к. их пока нет в природе.

Замена '$' -> 'P', думаю, хорошо, т.к., по крайней мере, совпадает с таковым в эксплорере - не будет разночтений.

Vertigo

2013-02-19 14:13

reporter   bugnote:0010322

Last edited: 2013-02-19 14:16

View 2 revisions

Обнаружил проблему в 3205 с копированием дедуплицированных файлов с сетевого диска.
Если копировать отдельный файл, то всё хорошо. А если скопировать папку, в которой лежат такие файлы, то они копируются в "сыром виде", как соответствующие репарс-пойнты. Естественно, ничего полезного потом сделать с ними, кроме как удалить, нельзя. При этом атрибут Sparse у них снимается.

Скорее всего, это побочный эффект последних правок, т.к. раньше такого не замечал.

2useven10

2013-02-19 15:23

developer   bugnote:0010323

Last edited: 2013-02-19 16:12

View 3 revisions

ставьте при копировании
[x] Copy contents of symbolic links
должно помочь.

хотя, конечно, надо чтобы это делалось автоматически.
кстати обычные файловые линки тоже копируются 'как есть' и даже флаг не помогает.

правильнее наверное завести новый инц о копировании ссылок...

последние правки здесь ничего не изменили. старые версии копируют также.

DrKnS

2013-02-19 21:50

administrator   bugnote:0010324

> кстати обычные файловые линки тоже копируются 'как есть' и даже флаг не помогает.

проверял?

2useven10

2013-02-19 22:31

developer   bugnote:0010325

был уверен, что да... но был неправ, с флагом всё в порядке.

Vertigo

2013-02-20 12:02

reporter   bugnote:0010326

Безусловно, указанная галочка помогает. Но, согласитесь, обычный пользователь не обязан знать, что где-то на сервере включена дедупликация, и, тем более, как она технически реализована. Кроме того, включённая галочка не даст скопировать именно реальные линки как есть.

2useven10, по крайней мере Far2 b1807 правильно копирует папки с такими файлами. Могу проверить предыдущие билды Far3, но что-то мне подсказывает, что там тоже всё хорошо.

В 3212 с отображением в панелях полный порядок. Осталась проблема с копированием. Заводить отдельный инцидент, или доделаете в рамках этого?

Vertigo

2013-02-20 12:15

reporter   bugnote:0010327

Хм, в 2798 проблема в копированием тоже актуальна. Более ранних билдов у меня нет.
Но в Far2 точно всё в порядке.
Тогда, наверное, отдельный инцидент?

2useven10

2013-02-20 14:05

developer   bugnote:0010328

Last edited: 2013-02-20 14:05

View 2 revisions

не надо новый. в этом доделаем.

DrKnS

2013-02-20 14:11

administrator   bugnote:0010329

Копировать 'в сыром виде' надо только известные науке репарспоинты, т.е. volume mount points и symlinks.

Остальные - как есть, ОС разберётся, что надо делать.

2useven10

2013-02-20 14:20

developer   bugnote:0010330

не могу не согласиться.
ближе к вечеру доделаю, сейчас времени нет.
там ещё логика копирования из сети не работала (тип источника не определялся),
поправил, но пока не коммитил.

Vertigo

2013-02-21 11:41

reporter   bugnote:0010358

Да, теперь копирование работает правильно.
Спасибо!

Issue History

Date Modified Username Field Change
2013-02-14 22:50 Vertigo New Issue
2013-02-14 23:00 DrKnS Note Added: 0010294
2013-02-14 23:24 DrKnS Assigned To => DrKnS
2013-02-14 23:24 DrKnS Status new => assigned
2013-02-14 23:26 DrKnS Note Added: 0010295
2013-02-15 13:28 Vertigo Note Added: 0010297
2013-02-18 17:36 2useven10 Note Added: 0010314
2013-02-18 17:36 2useven10 Status assigned => feedback
2013-02-18 17:58 DrKnS Note Added: 0010315
2013-02-18 18:11 2useven10 Note Added: 0010316
2013-02-18 21:15 2useven10 Note Added: 0010317
2013-02-18 21:22 Vertigo Note Added: 0010318
2013-02-18 21:22 Vertigo Status feedback => assigned
2013-02-18 22:28 2useven10 Note Added: 0010319
2013-02-19 12:20 2useven10 Note Added: 0010320
2013-02-19 12:28 2useven10 Status assigned => feedback
2013-02-19 14:09 Vertigo Note Added: 0010321
2013-02-19 14:09 Vertigo Status feedback => assigned
2013-02-19 14:13 Vertigo Note Added: 0010322
2013-02-19 14:16 Vertigo Note Edited: 0010322 View Revisions
2013-02-19 15:23 2useven10 Note Added: 0010323
2013-02-19 15:23 2useven10 Note Edited: 0010323 View Revisions
2013-02-19 16:12 2useven10 Note Edited: 0010323 View Revisions
2013-02-19 21:50 DrKnS Note Added: 0010324
2013-02-19 22:31 2useven10 Note Added: 0010325
2013-02-20 12:02 Vertigo Note Added: 0010326
2013-02-20 12:15 Vertigo Note Added: 0010327
2013-02-20 14:05 2useven10 Note Added: 0010328
2013-02-20 14:05 2useven10 Note Edited: 0010328 View Revisions
2013-02-20 14:11 DrKnS Note Added: 0010329
2013-02-20 14:20 2useven10 Note Added: 0010330
2013-02-20 17:56 2useven10 Status assigned => feedback
2013-02-21 11:41 Vertigo Note Added: 0010358
2013-02-21 11:41 Vertigo Status feedback => assigned
2013-02-21 16:49 2useven10 Build => 3215
2013-02-21 16:49 2useven10 Status assigned => closed
2013-02-21 16:49 2useven10 Resolution open => fixed
2013-02-21 16:49 2useven10 Fixed in Version => 3.0
2015-02-10 16:16 2useven10 Relationship added related to 0001711
2015-02-10 16:25 2useven10 Relationship added related to 0002935